﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace WinFormSQLCs
{
    class DataAccessClass : IDisposable
    {
        internal DataSet GetTitleDs(String userID, String password, String keyword)
        {
            DataSet ds = new DataSet();
            using (SqlConnection _cn = new SqlConnection())
            {
                _cn.ConnectionString = 
                    String.Format(WinFormSQLCs.Properties.Settings.Default.ConnectonString,
                    userID,
                    password);
                _cn.Open();
                using (SqlCommand _cmd = new SqlCommand())
                {
                    _cmd.Connection = _cn;
                    _cmd.CommandText = @"SELECT * " +
                                          "FROM titles " +
                                         "WHERE title LIKE @Title";
                    _cmd.Parameters.Add(new SqlParameter(@"Title", @"%" + keyword + @"%"));
                    using (SqlDataAdapter _da = new SqlDataAdapter())
                    {
                        _da.SelectCommand = _cmd;
                        _da.Fill(ds, "TitleList");
                        ds.Tables["TitleList"].PrimaryKey = 
                            new DataColumn[] { ds.Tables["TitleList"].Columns["title_id"] };
                    }
                }
            }
            return ds;
        }

        internal DataSet GetTitleDsItem(String userID, String password, String titleID)
        {
            DataSet ds = new DataSet();
            using (SqlConnection _cn = new SqlConnection())
            {
                _cn.ConnectionString = String.Format(WinFormSQLCs.Properties.Settings.Default.ConnectonString,
                    userID,
                    password);
                _cn.Open();
                using (SqlCommand _cmd = new SqlCommand())
                {
                    _cmd.Connection = _cn;
                    _cmd.CommandText = @"SELECT * " +
                                          "FROM titles " +
                                          "WHERE title_id=@TitleID";
                    _cmd.Parameters.Add(new SqlParameter(@"TitleID", titleID));
                    using (SqlDataAdapter _da = new SqlDataAdapter())
                    {
                        _da.SelectCommand = _cmd;
                        _da.Fill(ds, "EditTitle");
                        ds.Tables["EditTitle"].PrimaryKey = new DataColumn[] { ds.Tables["EditTitle"].Columns["title_id"] };
                    }
                }
            }
            return ds;
        }

        internal Boolean SetTitleDsItem(String userID, String password, String titleID, DataSet ds)
        {
            Boolean isOK = false;
            using (SqlConnection _cn = new SqlConnection())
            {
                _cn.ConnectionString = 
                    String.Format(WinFormSQLCs.Properties.Settings.Default.ConnectonString,
                    userID,
                    password);
                _cn.Open();
                using (SqlTransaction _tr = _cn.BeginTransaction())
                {
                    try
                    {
                        using (SqlCommand _cmd = new SqlCommand())
                        {
                            _cmd.Connection = _cn;
                            _cmd.Transaction = _tr;
                            _cmd.CommandText = @"SELECT * " +
                                                  "FROM titles " +
                                                  "WHERE title_id=@TitleID";
                            _cmd.Parameters.Add(new SqlParameter(@"TitleID", titleID));
                            using (SqlDataAdapter _da = new SqlDataAdapter())
                            {
                                _da.SelectCommand = _cmd;
                                using (SqlCommandBuilder _cb = new SqlCommandBuilder(_da))
                                {
                                    _cb.ConflictOption = ConflictOption.OverwriteChanges;
                                    _cb.GetInsertCommand(true).Connection = _cn;
                                    _cb.GetInsertCommand(true).Transaction = _tr;
                                    _cb.GetUpdateCommand(true).Connection = _cn;
                                    _cb.GetUpdateCommand(true).Transaction = _tr;
                                    _cb.GetDeleteCommand(true).Connection = _cn;
                                    _cb.GetDeleteCommand(true).Transaction = _tr;
                                    _da.Update(ds, "EditTitle");
                                }
                                _tr.Commit();
                            }
                            isOK = true;
                        }
                    }
                    catch (Exception ex)
                    {
                        _tr.Rollback();
                        throw ex;
                    }
                }
            }
            return isOK;
        }


        #region IDisposable メンバー

        public void Dispose()
        {
        }

        #endregion
    }
}
