﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WinFormSQLCs
{
    public partial class Edit_Form : Form
    {
        public Edit_Form()
        {
            InitializeComponent();
        }

        private String EditUserID = null;
        private String EditPassword = null;
        private String EditTitleID = null;
        private DataSet EditDs = null;
        private Boolean IsUpdate = false;

        internal DataRow EditRow
        {
            get
            {
                if (this.EditDs.Tables["EditTitle"].Rows.Count > 0)
                {
                    return this.EditDs.Tables["EditTitle"].Rows[0];
                }
                else
                {
                    return null;
                }
            }
        }

        public DialogResult ShowDialog(IWin32Window owner,
                                       String userID,
                                       String password,
                                       String titleID)
        {
            this.EditUserID = userID;
            this.EditPassword = password;
            this.EditTitleID = titleID;
            return base.ShowDialog(owner);
        }

        [System.Obsolete("ShowDialog(IWin32Window owner, String userID, String password, String titleID)を使用してください。", true)]
        public new DialogResult ShowDialog(IWin32Window owner)
        {
            throw new Exception("Edit_Formの呼び出し形式に誤りがあります。");
        }
        [System.Obsolete("ShowDialog(IWin32Window owner, String userID, String password, String titleID)を使用してください。", true)]
        public new DialogResult ShowDialog()
        {
            throw new Exception("Edit_Formの呼び出し形式に誤りがあります。");
        }
        [System.Obsolete("ShowDialog(IWin32Window owner, String userID, String password, String titleID)を使用してください。", true)]
        public new DialogResult Show(IWin32Window owner)
        {
            throw new Exception("Edit_Formの呼び出し形式に誤りがあります。");
        }
        [System.Obsolete("ShowDialog(IWin32Window owner, String userID, String password, String titleID)を使用してください。", true)]
        public new DialogResult Showg()
        {
            throw new Exception("Edit_Formの呼び出し形式に誤りがあります。");
        }

        private void Me_Load(object sender, EventArgs e)
        {
            DisplayClear();
            this.TitleId_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.Title_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.Type_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.PubId_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.Price_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.Advance_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.Royalty_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.YtdSales_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.Notes_TextBox.TextChanged += new System.EventHandler(this.EditTextChanged);
            this.Pubdate_DateTimePicker.TextChanged += new System.EventHandler(this.EditTextChanged);
        }

        private void DisplayClear()
        {
            foreach (Control cont in this.Controls)
            {
                if (cont is TextBox)
                {
                    cont.Text = string.Empty;
                }
                else if (cont is DateTimePicker)
                {
                    ((DateTimePicker)cont).Value = DateTime.Now.Date;
                }
            }
        }

        private void Me_Shown(object sender, EventArgs e)
        {
            this.Text = String.Format((string)this.Tag, EditTitleID);
            this.Cursor = Cursors.WaitCursor;
            try
            {
                using (DataAccessClass _proc = new DataAccessClass())
                {
                    this.EditDs = _proc.GetTitleDsItem(this.EditUserID,
                                                       this.EditPassword,
                                                       this.EditTitleID);
                    //this.TitleId_TextBox.Text = (String)this.EditDs.Tables["EditTitle"].Rows[0]["title_id"];
                    //this.Title_TextBox.Text = (String)this.EditDs.Tables["EditTitle"].Rows[0]["title"];
                    //this.Type_TextBox.Text = (String)this.EditDs.Tables["EditTitle"].Rows[0]["type"];
                    //this.PubId_TextBox.Text = (String)this.EditDs.Tables["EditTitle"].Rows[0]["pub_id"];
                    //this.Price_TextBox.Text = this.EditDs.Tables["EditTitle"].Rows[0]["price"] as String;
                    //this.Advance_TextBox.Text = this.EditDs.Tables["EditTitle"].Rows[0]["advance"] as String;
                    //this.Royalty_TextBox.Text = this.EditDs.Tables["EditTitle"].Rows[0]["royalty"] as String;
                    //this.YtdSales_TextBox.Text = this.EditDs.Tables["EditTitle"].Rows[0]["ytd_sales"] as String;
                    //this.Notes_TextBox.Text = this.EditDs.Tables["EditTitle"].Rows[0]["notes"] as String;
                    //this.Pubdate_DateTimePicker.Value = (DateTime)this.EditDs.Tables["EditTitle"].Rows[0]["pubdate"];
                    this.Edit_BindingSource.DataSource = this.EditDs.Tables["EditTitle"];
                    this.TitleId_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "title_id",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.Title_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "title",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.Type_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "type",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.PubId_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "pub_id",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.Price_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "price",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.Advance_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "advance",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.Royalty_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "royalty",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.YtdSales_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "ytd_sales",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.Notes_TextBox.DataBindings.Add(new Binding("Text",
                        this.Edit_BindingSource,
                        "notes",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    this.Pubdate_DateTimePicker.DataBindings.Add(new Binding("Value",
                        this.Edit_BindingSource,
                        "pubdate",
                        true,
                        DataSourceUpdateMode.OnValidation,
                        String.Empty));
                    if (this.EditDs.Tables["EditTitle"].Rows.Count > 0)
                    {
                        this.OK_Button.Enabled = true;
                    }
                    else
                    {
                        this.OK_Button.Enabled = false;
                    }
                    IsUpdate = false;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text);
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }

        private void EditTextChanged(object sender,
                            System.EventArgs e)
        {
            this.IsUpdate = true;
        }

        private void OK_Button_Click(object sender, EventArgs e)
        {
            this.IsUpdate = !IsDataUpdate();
            this.DialogResult = DialogResult.OK;
        }

        private Boolean IsDataUpdate()
        {
            Boolean isOK = false;

            try
            {
                this.Edit_BindingSource.EndEdit();
                //this.EditDs.Tables["EditTitle"].Rows[0].BeginEdit();
                //this.EditDs.Tables["EditTitle"].Rows[0]["title_id"] = this.TitleId_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["title"] = this.Title_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["type"] = this.Type_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["pub_id"] = this.PubId_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["price"] =  this.Price_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["advance"] = this.Advance_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["royalty"] = this.Royalty_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["ytd_sales"] = this.YtdSales_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["notes"] = this.Notes_TextBox.Text;
                //this.EditDs.Tables["EditTitle"].Rows[0]["pubdate"] = this.Pubdate_DateTimePicker.Value;
                //this.EditDs.Tables["EditTitle"].Rows[0].EndEdit();
                using (DataAccessClass _proc = new DataAccessClass())
                {
                    isOK = _proc.SetTitleDsItem(this.EditUserID,
                                                this.EditPassword,
                                                this.EditTitleID,
                                                this.EditDs);
                }
                isOK = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text);
            }
            return isOK;
        }

        private void Me_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (IsUpdate)
            {
                DialogResult result = MessageBox.Show("データが保存されていません。" + Environment.NewLine +
                    "[はい]:保存して編集終了" + Environment.NewLine +
                    "[いいえ]:保存せずに編集終了" + Environment.NewLine +
                    "[キャンセル]:編集に戻る",
                    this.Text,
                    MessageBoxButtons.YesNoCancel,
                    MessageBoxIcon.Information,
                    MessageBoxDefaultButton.Button3);
                switch (result)
                {
                    case DialogResult.Yes:
                        e.Cancel = IsDataUpdate();
                        break;
                    case DialogResult.No:
                        IsUpdate = false;
                        break;
                    case DialogResult.Cancel:
                        IsUpdate = true;
                        break;
                }
            }
        }
    }
}
