﻿using System;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace WinFormSQLCs
{
    public partial class Login_Form : Form
    {
        public Login_Form()
        {
            InitializeComponent();
        }

        public String UserID { get; set; }
        public String Password { get; set; }

        private void OK_Button_Click(object sender, EventArgs e)
        {
            using (SqlConnection _cn = new SqlConnection())
            {
                try
                {
                    _cn.ConnectionString = String.Format(WinFormSQLCs.Properties.Settings.Default.ConnectonString,
                        this.UsernameTextBox.Text,
                        this.PasswordTextBox.Text);
                    _cn.Open();
                    UserID = this.UsernameTextBox.Text;
                    Password = this.PasswordTextBox.Text;
                    this.DialogResult = System.Windows.Forms.DialogResult.OK;
                    this.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, this.Text);
                }
            }
        }

        private void Cancel_Button_Click(object sender, EventArgs e)
        {
            this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.Close();
        }

        private void Me_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (this.DialogResult != DialogResult.OK)
            {
                UserID = String.Empty;
                Password = String.Empty;
            }
        }
    }
}
