﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WinFormSQLCs
{
    public partial class WinFormSQL_Form : Form
    {
        private String UserID;
        private String Password;

        public WinFormSQL_Form()
        {
            InitializeComponent();
        }

        private void Me_Load(object sender, EventArgs e)
        {
            this.Result_DataGridView.AutoGenerateColumns = false;
            DisplayClear();
        }

        private void DisplayClear()
        {
            this.Search_TextBox.Text = String.Empty;
            this.Result_DataGridView.DataSource = null;
            this.Message_ToolStripStatusLabel.Text = String.Empty;
        }

        private void Me_Shown(object sender, EventArgs e)
        {
            using (Login_Form _form = new Login_Form())
            {
                if (_form.ShowDialog(this) == DialogResult.OK)
                {
                    this.UserID = _form.UserID;
                    this.Password = _form.Password;
                }
                else
                {
                    this.Close();
                }
            }
        }

        private void Search_Button_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                using (DataAccessClass _proc = new DataAccessClass())
                {
                    this.Result_DataGridView.DataSource = _proc.GetTitleDs(this.UserID,
                        this.Password,
                        this.Search_TextBox.Text.Trim());
                    this.Result_DataGridView.DataMember = @"TitleList";
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Text);
                this.Message_ToolStripStatusLabel.Text = ex.Message;
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }

        private void Result_DataGridView_CellMouseDown(object sender,
            DataGridViewCellMouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                if (this.Result_DataGridView.Rows.Count > 0 &&
                    this.Result_DataGridView.SelectedRows.Count > 0)
                {
                    Edit_ContextMenuStrip.Enabled = true;
                }
                else
                {
                    Edit_ContextMenuStrip.Enabled = false;
                }
                Edit_ContextMenuStrip.Show(new Point(Cursor.Position.X,
                    Cursor.Position.Y));
            }
        }

        private void Edit_ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.Result_DataGridView.Rows.Count > 0 &&
                this.Result_DataGridView.SelectedRows.Count > 0)
            {
                DataGridViewRow row  = this.Result_DataGridView.SelectedRows[0];
                using (Edit_Form _form = new Edit_Form())
                {
                    if (_form.ShowDialog(this,
                        UserID,
                        Password,
                        (string)this.Result_DataGridView.SelectedRows[0].Cells["TitleID_TextBox"].Value) == DialogResult.OK) 
                    {
                        if (_form.EditRow != null) {
                            DataRow editrow =_form.EditRow;
                            for (int index = 0; index <= this.Result_DataGridView.ColumnCount-1; index++) {
                                row.Cells[index].Value =editrow[this.Result_DataGridView.Columns[index].DataPropertyName];
                            }
                        }
                    }
                }
            }
        }
    }
}
